/*
 * This file automatically produced by /usr/local/mathematica/AddOns/MathLink/DevelopersKits/Solaris/CompilerAdditions/mprep from:
 *	mathpng.tm
 * mprep Revision 5 (c) Copyright Wolfram Research, Inc. 1990-1996
 */


int MLAbort = 0;
int MLDone  = 0;
long MLSpecialCharacter = '\0';

#include "mathlink.h"
MLINK stdlink = 0;
MLEnvironment stdenv = 0;
MLYieldFunctionObject stdyielder = 0;
MLMessageHandlerObject stdhandler = 0;

/*1:*/
#line 4 "mathpng.w"

/*39:*/
#line 694 "mathpng.w"

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "png.h"
#include "mathlink.h"

/*:39*/
#line 5 "mathpng.w"

/*11:*/
#line 181 "mathpng.w"

void ReadPNGFile(const char*fname)
{
char*gamma_str;
char file_name[256];
double screen_gamma,image_gamma;
png_uint_32 row;
png_structp png_ptr= NULL;
png_infop info_ptr= NULL;
png_uint_32 width,height;
int bit_depth,color_type,interlace_type;
png_bytep*row_pointers,trans= NULL;
int num_trans= -1;
png_color_16*trans_values= NULL;
const int ReadFile= 1;
FILE*fp;

/*38:*/
#line 675 "mathpng.w"

{
int i,j,n;

n= strlen(fname);
for(j= i= 0;i<n;i++)
if(fname[i]!='\\')
file_name[j++]= fname[i];
else if(fname[++i]=='\\')
file_name[j++]= '\\';
file_name[j++]= fname[n];file_name[j+1]= '\0';
#ifdef __WIN32__
n= strlen(file_name);
for(i= 0;i<n;i++)
if('/'==file_name[i])file_name[i]= '\\';
#endif
}


/*:38*/
#line 198 "mathpng.w"

if((fp= fopen(file_name,"rb"))==NULL)
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 200 "mathpng.w"

/*13:*/
#line 285 "mathpng.w"

png_ptr= png_create_read_struct(PNG_LIBPNG_VER_STRING,
(void*)NULL,NULL,NULL);
if(png_ptr==NULL)
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 289 "mathpng.w"


/*:13*/
#line 201 "mathpng.w"

/*15:*/
#line 304 "mathpng.w"

info_ptr= png_create_info_struct(png_ptr);
if(info_ptr==NULL)
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 307 "mathpng.w"


/*:15*/
#line 202 "mathpng.w"

/*16:*/
#line 312 "mathpng.w"

if(setjmp(png_ptr->jmpbuf))
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 314 "mathpng.w"


/*:16*/
#line 203 "mathpng.w"

/*17:*/
#line 317 "mathpng.w"

png_init_io(png_ptr,fp);


/*:17*/
#line 204 "mathpng.w"



png_read_info(png_ptr,info_ptr);

png_get_IHDR(png_ptr,info_ptr,&width,&height,&bit_depth,&color_type,
&interlace_type,NULL,NULL);
png_get_tRNS(png_ptr,info_ptr,&trans,&num_trans,&trans_values);
#ifdef NO_COLOR16

png_set_strip_16(png_ptr);
#endif


if(color_type==PNG_COLOR_TYPE_PALETTE||bit_depth<8)
png_set_expand(png_ptr);



if(png_get_valid(png_ptr,info_ptr,PNG_INFO_tRNS))
png_set_expand(png_ptr);


if((gamma_str= getenv("DISPLAY_GAMMA"))!=NULL)
screen_gamma= atof(gamma_str);

else
screen_gamma= 2.2;






if(png_get_gAMA(png_ptr,info_ptr,&image_gamma))
png_set_gamma(png_ptr,screen_gamma,image_gamma);
else
png_set_gamma(png_ptr,screen_gamma,0.45);


if(!(color_type&PNG_COLOR_MASK_ALPHA)&&num_trans<0)
png_set_filler(png_ptr,0xff,PNG_FILLER_AFTER);




png_read_update_info(png_ptr,info_ptr);

/*18:*/
#line 322 "mathpng.w"

row_pointers= calloc(height,sizeof(png_bytep));
for(row= 0;row<height;row++)
row_pointers[row]= malloc(png_get_rowbytes(png_ptr,info_ptr));

/*:18*/
#line 252 "mathpng.w"

png_read_image(png_ptr,row_pointers);
/*3:*/
#line 62 "mathpng.w"

{
int i,j;
int row_bytes;
png_bytep row;
int pixel_no;

row_bytes= png_get_rowbytes(png_ptr,info_ptr);
MLPutFunction(stdlink,"List",5);
MLPutFunction(stdlink,"List",height);
for(i= height-1;i>-1;i--){
row= row_pointers[i];
if(bit_depth<=8)
/*4:*/
#line 107 "mathpng.w"

{
MLPutFunction(stdlink,"List",row_bytes);
for(j= 0;j<row_bytes;j++)
MLPutInteger(stdlink,(int)row[j]);
}

/*:4*/
#line 75 "mathpng.w"

else{
if(!(color_type|PNG_COLOR_MASK_COLOR))
/*5:*/
#line 114 "mathpng.w"

{
pixel_no= row_bytes>>1;
MLPutFunction(stdlink,"List",pixel_no);
for(j= 0;j<row_bytes;j+= 2)
MLPutInteger(stdlink,(row[j]<<8)+row[j+1]);
}

/*:5*/
#line 78 "mathpng.w"

else
/*6:*/
#line 122 "mathpng.w"

{
pixel_no= row_bytes>>1;
MLPutFunction(stdlink,"List",pixel_no);
for(j= 0;j<row_bytes;j+= 2)
MLPutInteger(stdlink,(row[j]<<8)+row[j+1]);
}

/*:6*/
#line 80 "mathpng.w"

}
}
MLPutInteger(stdlink,width);
MLPutInteger(stdlink,height);
MLPutInteger(stdlink,(bit_depth<8?8:bit_depth));
switch(color_type){
case PNG_COLOR_TYPE_GRAY:
MLPutSymbol(stdlink,"PNGBitmap`PNGColorGray");
break;
case PNG_COLOR_TYPE_PALETTE:
MLPutSymbol(stdlink,"PNGBitmap`PNGColorPalette");
break;
case PNG_COLOR_TYPE_RGB:
MLPutSymbol(stdlink,"PNGBitmap`PNGColorRGB");
break;
case PNG_COLOR_TYPE_RGB_ALPHA:
MLPutSymbol(stdlink,"PNGBitmap`PNGColorRGBA");
break;
case PNG_COLOR_TYPE_GRAY_ALPHA:
MLPutSymbol(stdlink,"PNGBitmap`PNGColorGrayA");
break;
default:
MLPutSymbol(stdlink,"PNGBitmap`PNGColorUnkown");
}
}

/*:3*/
#line 254 "mathpng.w"


png_read_end(png_ptr,info_ptr);


png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
/*19:*/
#line 327 "mathpng.w"

if(row_pointers){
for(row= 0;row<height;row++)
if(row_pointers[row])free(row_pointers[row]);
free(row_pointers);
}

/*:19*/
#line 260 "mathpng.w"


fclose(fp);
return;
}

/*:11*/
#line 6 "mathpng.w"

/*22:*/
#line 351 "mathpng.w"

void WritePNGFile(const char*fname,
int width,int height,int bit_depth,int png_fmt,double gamma)
{
FILE*fp;
char file_name[256];

png_structp png_ptr;
png_infop info_ptr;
const int ReadFile= 0;
int row,png_color_type;
png_color_8 sig_bit;
png_bytep*row_pointers;

/*28:*/
#line 486 "mathpng.w"

/*38:*/
#line 675 "mathpng.w"

{
int i,j,n;

n= strlen(fname);
for(j= i= 0;i<n;i++)
if(fname[i]!='\\')
file_name[j++]= fname[i];
else if(fname[++i]=='\\')
file_name[j++]= '\\';
file_name[j++]= fname[n];file_name[j+1]= '\0';
#ifdef __WIN32__
n= strlen(file_name);
for(i= 0;i<n;i++)
if('/'==file_name[i])file_name[i]= '\\';
#endif
}


/*:38*/
#line 487 "mathpng.w"

fp= fopen(file_name,"wb");
if(fp==NULL){
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:28*/
#line 365 "mathpng.w"

/*14:*/
#line 297 "mathpng.w"

png_ptr= png_create_write_struct(PNG_LIBPNG_VER_STRING,
(void*)NULL,NULL,NULL);
if(png_ptr==NULL)
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 301 "mathpng.w"


/*:14*/
#line 366 "mathpng.w"

/*15:*/
#line 304 "mathpng.w"

info_ptr= png_create_info_struct(png_ptr);
if(info_ptr==NULL)
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 307 "mathpng.w"


/*:15*/
#line 367 "mathpng.w"

/*16:*/
#line 312 "mathpng.w"

if(setjmp(png_ptr->jmpbuf))
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 314 "mathpng.w"


/*:16*/
#line 368 "mathpng.w"

/*17:*/
#line 317 "mathpng.w"

png_init_io(png_ptr,fp);


/*:17*/
#line 369 "mathpng.w"

/*29:*/
#line 501 "mathpng.w"

switch(png_fmt){
case 1:png_color_type= PNG_COLOR_TYPE_GRAY;
sig_bit.gray= (unsigned char)bit_depth;
break;
case 3:png_color_type= PNG_COLOR_TYPE_RGB;
sig_bit.red= sig_bit.green= sig_bit.blue= (unsigned char)bit_depth;
break;
case 4:png_color_type= PNG_COLOR_TYPE_RGB_ALPHA;
sig_bit.red= sig_bit.green= (unsigned char)bit_depth;
sig_bit.blue= sig_bit.alpha= (unsigned char)bit_depth;
break;
default:png_color_type= PNG_COLOR_TYPE_RGB_ALPHA;
sig_bit.red= sig_bit.green= (unsigned char)bit_depth;
sig_bit.blue= sig_bit.alpha= (unsigned char)bit_depth;
break;
}
png_set_IHDR(png_ptr,info_ptr,
width,height,bit_depth,
png_color_type,
PNG_INTERLACE_NONE,
PNG_COMPRESSION_TYPE_DEFAULT,
PNG_FILTER_TYPE_BASE);
png_set_sBIT(png_ptr,info_ptr,&sig_bit);

/*:29*/
#line 370 "mathpng.w"



png_set_gAMA(png_ptr,info_ptr,gamma);

png_write_info(png_ptr,info_ptr);
/*30:*/
#line 528 "mathpng.w"


png_set_packing(png_ptr);

/*:30*/
#line 376 "mathpng.w"

/*7:*/
#line 131 "mathpng.w"

{
int i,j,k;
long row_bytes;
long rb_alloc;
png_bytep row;
long imh;
int*img_row;

rb_alloc= png_get_rowbytes(png_ptr,info_ptr);
row_pointers= calloc(height,sizeof(png_bytep));

if(!MLCheckFunction(stdlink,"List",&imh)&&imh!=height)
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 144 "mathpng.w"

for(i= height-1;i>-1;i--){
MLGetIntegerList(stdlink,&img_row,&row_bytes);
row_pointers[i]= calloc(rb_alloc,sizeof(png_byte));
row= row_pointers[i];
if(bit_depth==8){
for(j= 0;j<row_bytes;j++)
row[j]= (png_byte)img_row[j];
}
else if(bit_depth==16){
for(k= j= 0;j<row_bytes;j++){
row[k++]= (png_byte)(img_row[j]>>8);
row[k++]= (png_byte)(img_row[j]);
if(k>=rb_alloc)break;
}
}
MLDisownIntegerList(stdlink,img_row,row_bytes);
}
}

/*:7*/
#line 377 "mathpng.w"

png_write_image(png_ptr,row_pointers);
png_write_end(png_ptr,info_ptr);
/*19:*/
#line 327 "mathpng.w"

if(row_pointers){
for(row= 0;row<height;row++)
if(row_pointers[row])free(row_pointers[row]);
free(row_pointers);
}

/*:19*/
#line 380 "mathpng.w"


png_destroy_write_struct(&png_ptr,(png_infopp)NULL);

fclose(fp);
MLPutString(stdlink,file_name);
return;
}

/*:22*/
#line 7 "mathpng.w"

/*24:*/
#line 399 "mathpng.w"

void WritePNGGraphics(const char*fname,double gamma)
{
FILE*fp;
char file_name[256];
char*uni_str,*end_str;
char*sp,*pbm,*image_data;
long int j;
unsigned long i;
unsigned long len;
const int png_fmt= 3;
int width,height,bit_depth;
png_structp png_ptr;
png_infop info_ptr;
const int ReadFile= 0;
int png_color_type;
png_color_8 sig_bit;
png_bytep*row_pointers;

/*25:*/
#line 453 "mathpng.w"

MLGetString(stdlink,(const char**)&uni_str);
len= strlen(uni_str);
end_str= uni_str+len;
image_data= pbm= (char*)calloc(len,sizeof(char));
for(j= i= 0,sp= uni_str;i<len;i++){
pbm[j++]= (char)MLNextCharacter((const char**)&sp,(const char*)end_str);
if(!pbm)break;
}
MLDisownString(stdlink,uni_str);

/*:25*/
#line 418 "mathpng.w"

/*26:*/
#line 464 "mathpng.w"

{

while(*pbm!='\012')pbm++;
sscanf(++pbm,"%d %d\n",&width,&height);
while(*pbm!='\012')pbm++;
sscanf(++pbm,"%d",&bit_depth);
bit_depth= 8;
while(*pbm!='\012')pbm++;
pbm++;
}

/*:26*/
#line 419 "mathpng.w"

/*28:*/
#line 486 "mathpng.w"

/*38:*/
#line 675 "mathpng.w"

{
int i,j,n;

n= strlen(fname);
for(j= i= 0;i<n;i++)
if(fname[i]!='\\')
file_name[j++]= fname[i];
else if(fname[++i]=='\\')
file_name[j++]= '\\';
file_name[j++]= fname[n];file_name[j+1]= '\0';
#ifdef __WIN32__
n= strlen(file_name);
for(i= 0;i<n;i++)
if('/'==file_name[i])file_name[i]= '\\';
#endif
}


/*:38*/
#line 487 "mathpng.w"

fp= fopen(file_name,"wb");
if(fp==NULL){
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:28*/
#line 420 "mathpng.w"

/*14:*/
#line 297 "mathpng.w"

png_ptr= png_create_write_struct(PNG_LIBPNG_VER_STRING,
(void*)NULL,NULL,NULL);
if(png_ptr==NULL)
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 301 "mathpng.w"


/*:14*/
#line 421 "mathpng.w"

/*15:*/
#line 304 "mathpng.w"

info_ptr= png_create_info_struct(png_ptr);
if(info_ptr==NULL)
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 307 "mathpng.w"


/*:15*/
#line 422 "mathpng.w"

/*16:*/
#line 312 "mathpng.w"

if(setjmp(png_ptr->jmpbuf))
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 314 "mathpng.w"


/*:16*/
#line 423 "mathpng.w"

/*17:*/
#line 317 "mathpng.w"

png_init_io(png_ptr,fp);


/*:17*/
#line 424 "mathpng.w"

/*29:*/
#line 501 "mathpng.w"

switch(png_fmt){
case 1:png_color_type= PNG_COLOR_TYPE_GRAY;
sig_bit.gray= (unsigned char)bit_depth;
break;
case 3:png_color_type= PNG_COLOR_TYPE_RGB;
sig_bit.red= sig_bit.green= sig_bit.blue= (unsigned char)bit_depth;
break;
case 4:png_color_type= PNG_COLOR_TYPE_RGB_ALPHA;
sig_bit.red= sig_bit.green= (unsigned char)bit_depth;
sig_bit.blue= sig_bit.alpha= (unsigned char)bit_depth;
break;
default:png_color_type= PNG_COLOR_TYPE_RGB_ALPHA;
sig_bit.red= sig_bit.green= (unsigned char)bit_depth;
sig_bit.blue= sig_bit.alpha= (unsigned char)bit_depth;
break;
}
png_set_IHDR(png_ptr,info_ptr,
width,height,bit_depth,
png_color_type,
PNG_INTERLACE_NONE,
PNG_COMPRESSION_TYPE_DEFAULT,
PNG_FILTER_TYPE_BASE);
png_set_sBIT(png_ptr,info_ptr,&sig_bit);

/*:29*/
#line 425 "mathpng.w"



png_set_gAMA(png_ptr,info_ptr,gamma);

png_write_info(png_ptr,info_ptr);
/*30:*/
#line 528 "mathpng.w"


png_set_packing(png_ptr);

/*:30*/
#line 431 "mathpng.w"

/*27:*/
#line 476 "mathpng.w"

{int i;

png_get_rowbytes(png_ptr,info_ptr);
row_pointers= calloc(height,sizeof(png_bytep));
for(i= 0;i<height;i++)
row_pointers[i]= (png_bytep)(pbm+3*width*i);
}

/*:27*/
#line 432 "mathpng.w"

png_write_image(png_ptr,row_pointers);
png_write_end(png_ptr,info_ptr);
free(row_pointers);

png_destroy_write_struct(&png_ptr,(png_infopp)NULL);

fclose(fp);
MLPutFunction(stdlink,"List",5);
MLPutString(stdlink,file_name);
MLPutInteger(stdlink,width);
MLPutInteger(stdlink,height);
MLPutInteger(stdlink,bit_depth);
MLPutInteger(stdlink,strlen(image_data));
free(image_data);
return;
}

/*:24*/
#line 8 "mathpng.w"

/*32:*/
#line 544 "mathpng.w"

void MakeHexString(int*row,long len)
{char*hex,one[2];
long i;

hex= calloc(2*len+1,sizeof(char));
*hex= '\0';
for(i= 0L;i<len;i++){
sprintf(one,"%02X",(unsigned char)row[i]);
strcat(hex,one);
}
MLPutString(stdlink,hex);
free(hex);
}

/*:32*/
#line 9 "mathpng.w"

/*36:*/
#line 581 "mathpng.w"

#define Image(mat,i,j) mat[i+j*xsize]
#if defined(__BORLANDC__)
#  define LONGDOUBLE long double
#  define LONGLOG    logl
#  define LONGSQRT   sqrtl
#  define TWO        (2.0L)
#  define HALF       (0.5L)
#elif defined(__SUNPRO_C)
#  define LONGDOUBLE long double
#  define LONGLOG    log
#  define LONGSQRT   sqrt
#  define TWO        (2.0L)
#  define HALF       (0.5L)

#else
#  define LONGDOUBLE double
#  define LONGLOG    log
#  define LONGSQRT   sqrt
#  define TWO        (2.0)
#  define HALF       (0.5)
#endif

void RawMandelJulia(double x1,double y1,
double x2,double y2,
double cx,double cy,
double bound,
int makeJulia,
int xsize,int ysize,
int maxiter,
int makePot)
{int*mat= NULL;
double*dmat= NULL;
LONGDOUBLE dx,dy,pot;
int i,j,iter,k;
register LONGDOUBLE ccx,ccy,xx,yy,x,y,xsq,ysq,xsave,lbound;

if(makePot)
dmat= calloc(xsize*ysize,sizeof(double));
else
mat= calloc(xsize*ysize,sizeof(int));
lbound= (bound*bound);
ccx= (LONGDOUBLE)cx;
ccy= (LONGDOUBLE)cy;
dx= ((x2-x1)/(xsize-1));
dy= ((y2-y1)/(ysize-1));
for(i= 0;i<xsize;i++){
xx= (x1+dx*(i+HALF));
if(!makeJulia)ccx= xx;
for(j= 0;j<ysize;j++){
iter= 0;
x= xx;
yy= y= (y1+dy*(j+HALF));
if(!makeJulia)ccy= yy;
xsq= x*x;
ysq= y*y;
do{
xsave= x;
x= ccx+xsq-ysq;
y= ccy+TWO*y*xsave;
xsq= x*x;
ysq= y*y;
}
while(++iter<maxiter&&(xsq+ysq)<lbound);
if(!makePot)
Image(mat,i,j)= iter;
else{
if(iter==maxiter)
pot= 0.0;
else{
pot= LONGSQRT(xsq+ysq);
for(k= iter;k>0;k--)
pot= LONGSQRT(pot);
pot= LONGLOG(pot);
}
Image(dmat,i,j)= pot;
}
}
}

MLPutFunction(stdlink,"Partition",2);
if(!makePot)
MLPutIntegerList(stdlink,mat,xsize*ysize);
else
MLPutRealList(stdlink,dmat,xsize*ysize);
MLPutInteger(stdlink,xsize);
MLEndPacket(stdlink);
if(!makePot)
free(mat);
else
free(dmat);
}

/*:36*/
#line 10 "mathpng.w"

/*2:*/
#line 14 "mathpng.w"

#ifdef __WIN32__
#  if MLVERSION < 3

int PASCAL WinMain(HANDLE hinstCurrent,HANDLE hinstPrevious,
LPSTR lpszCmdLine,int nCmdShow)

{char buff[512];
char FAR*argv[32];
int argc;

if(!MLInitializeIcon(hinstCurrent,nCmdShow))return 1;
argc= MLStringToArgv(lpszCmdLine,buff,argv,32);
return MLMain(argc,argv);
}

#  else

int PASCAL WinMain(HANDLE hinstCurrent,HANDLE hinstPrevious,

LPSTR lpszCmdLine,int nCmdShow)

{

char buff[512];
char FAR*buff_start= buff;
char FAR*argv[32];
char FAR*FAR*argv_end= argv+32;

if(!MLInitializeIcon(hinstCurrent,nCmdShow))return 1;
MLScanString(argv,&argv_end,&lpszCmdLine,&buff_start);
return MLMain(argv_end-argv,argv);
}

#  endif

#else

int main(int argc,char*argv[]){

return MLMain(argc,argv);
}

#endif


/*:2*//*8:*/
#line 164 "mathpng.w"

/*:8*//*9:*/
#line 173 "mathpng.w"

/*:9*//*10:*/
#line 176 "mathpng.w"

/*:10*//*20:*/
#line 336 "mathpng.w"

/*:20*//*21:*/
#line 346 "mathpng.w"

/*:21*//*23:*/
#line 389 "mathpng.w"

/*:23*//*31:*/
#line 534 "mathpng.w"

/*:31*//*34:*/
#line 563 "mathpng.w"

/*:34*//*35:*/
#line 577 "mathpng.w"

/*:35*/
#line 11 "mathpng.w"


/*:1*/


void ReadPNGFile P(( kcharp_ct _tp1));

#if MLPROTOTYPES
static int _tr0( MLINK mlp)
#else
static int _tr0(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	kcharp_ct _tp1;
	if ( ! MLGetString( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	ReadPNGFile(_tp1);

	res = 1;
L1:	MLDisownString(mlp, _tp1);

L0:	return res;
} /* _tr0 */


void WritePNGFile P(( kcharp_ct _tp1, int _tp2, int _tp3, int _tp4, int _tp5, double _tp6));

#if MLPROTOTYPES
static int _tr1( MLINK mlp)
#else
static int _tr1(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	kcharp_ct _tp1;
	int _tp2;
	int _tp3;
	int _tp4;
	int _tp5;
	double _tp6;
	if ( ! MLGetString( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLGetInteger( mlp, &_tp4) ) goto L3;
	if ( ! MLGetInteger( mlp, &_tp5) ) goto L4;
	if ( ! MLGetReal( mlp, &_tp6) ) goto L5;

	WritePNGFile(_tp1, _tp2, _tp3, _tp4, _tp5, _tp6);

	res = 1;
 L5: L4: L3: L2: L1:	MLDisownString(mlp, _tp1);

L0:	return res;
} /* _tr1 */


void WritePNGGraphics P(( kcharp_ct _tp1, double _tp2));

#if MLPROTOTYPES
static int _tr2( MLINK mlp)
#else
static int _tr2(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	kcharp_ct _tp1;
	double _tp2;
	if ( ! MLGetString( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;

	WritePNGGraphics(_tp1, _tp2);

	res = 1;
 L1:	MLDisownString(mlp, _tp1);

L0:	return res;
} /* _tr2 */


void MakeHexString P(( intp_nt _tp1, long _tpl1));

#if MLPROTOTYPES
static int _tr3( MLINK mlp)
#else
static int _tr3(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	intp_nt _tp1;
	long _tpl1;
	if ( ! MLGetIntegerList( mlp, &_tp1, &_tpl1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	MakeHexString(_tp1, _tpl1);

	res = 1;
L1:	MLDisownIntegerList( mlp, _tp1, _tpl1);

L0:	return res;
} /* _tr3 */


void RawMandelJulia P(( double _tp1, double _tp2, double _tp3, double _tp4, double _tp5, double _tp6, double _tp7, int _tp8, int _tp9, int _tp10, int _tp11, int _tp12));

#if MLPROTOTYPES
static int _tr4( MLINK mlp)
#else
static int _tr4(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	double _tp1;
	double _tp2;
	double _tp3;
	double _tp4;
	double _tp5;
	double _tp6;
	double _tp7;
	int _tp8;
	int _tp9;
	int _tp10;
	int _tp11;
	int _tp12;
	if ( ! MLGetReal( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;
	if ( ! MLGetReal( mlp, &_tp3) ) goto L2;
	if ( ! MLGetReal( mlp, &_tp4) ) goto L3;
	if ( ! MLGetReal( mlp, &_tp5) ) goto L4;
	if ( ! MLGetReal( mlp, &_tp6) ) goto L5;
	if ( ! MLGetReal( mlp, &_tp7) ) goto L6;
	if ( ! MLGetInteger( mlp, &_tp8) ) goto L7;
	if ( ! MLGetInteger( mlp, &_tp9) ) goto L8;
	if ( ! MLGetInteger( mlp, &_tp10) ) goto L9;
	if ( ! MLGetInteger( mlp, &_tp11) ) goto L10;
	if ( ! MLGetInteger( mlp, &_tp12) ) goto L11;
	if ( ! MLNewPacket(mlp) ) goto L12;

	RawMandelJulia(_tp1, _tp2, _tp3, _tp4, _tp5, _tp6, _tp7, _tp8, _tp9, _tp10, _tp11, _tp12);

	res = 1;
L12: L11: L10: L9: L8: L7: L6: L5: L4: L3: L2: L1: 
L0:	return res;
} /* _tr4 */


static struct func {
	int   f_nargs;
	int   manual;
	int   (*f_func)P((MLINK));
	char  *f_name;
	} _tramps[5] = {
		{ 1, 0, _tr0, "ReadPNGFile" },
		{ 6, 2, _tr1, "WritePNGFile" },
		{ 2, 2, _tr2, "WritePNGGraphics" },
		{ 1, 0, _tr3, "MakeHexString" },
		{12, 0, _tr4, "RawMandelJulia" }
		};


static int  _definepattern P(( MLINK, char*, char*, int));

int  _MLDoCallPacket P(( MLINK, struct func[], int));


#if MLPROTOTYPES
int MLInstall( MLINK mlp)
#else
int MLInstall(mlp) MLINK mlp;
#endif
{
	int _res;
	_res = MLConnect(mlp);
	if (_res) _res = MLPutString(mlp, "Print[\"mathpng MathLink program installed. \\\\[Copyright] Jens-Peer Kuska 1998.\"]");
	if (_res) _res =  _definepattern(mlp, "PNGBitmap`RawReadPNGBitmap[pngfile_String]", "{pngfile}", 0);
	if (_res) _res = MLPutString(mlp, "SetAttributes[PNGBitmap,HoldAll]");
	if (_res) _res = MLPutString(mlp, "Format[PNGBitmap[data_,w_,h_,d_]]:=                                SequenceForm[\"PNGBitmap\",\"[\",\"<<image data>>\",\",\",w,\",\",h,\",\",d,\"]\"]");
	if (_res) _res =  _definepattern(mlp, "PNGBitmap`RawWritePNGBitmap[pngfile_String,w_Integer,h_Integer,                         bd_Integer,cno_Integer,gamma_Real,img_]", "{pngfile,w,h,bd,cno,gamma,img}", 1);
	if (_res) _res = MLPutString(mlp, "PNGBitmap`RawWritePNGBitmap[pngfile_String,                                   PNGBitmap[img_,w_Integer,h_Integer,bd_Integer]]:=                 PNGBitmap`WritePNGBitmap[pngfile,w,h,bd,4,2.2,img]");
	if (_res) _res =  _definepattern(mlp, "PNGBitmap`RawWritePNGGraphics[pngfile_String,                                                    gamma_Real,pbm_String]", "{pngfile,gamma,pbm}", 2);
	if (_res) _res =  _definepattern(mlp, "PNGBitmap`MakeHexRow[onerow_ /; VectorQ[onerow,IntegerQ]]", "{onerow}", 3);
	if (_res) _res =  _definepattern(mlp, "PNGBitmap`RawMandelJulia[x1_Real,y1_Real,x2_Real,y2_Real,                                                cx_Real,cy_Real,                                                                b_Real,makeJulia_Integer,                                                       xsize_Integer,ysize_Integer,                                                    maxit_Integer,makePot_Integer]", "{x1,y1,x2,y2,cx,cy,b,makeJulia,xsize,ysize,maxit,makePot}", 4);
	if (_res) _res = MLPutString(mlp, "PNGBitmap`RawMandelJulia[x1_,y1_,x2_,y2_,b_]:=                                    PNGBitmap`RawMandelJulia[x1,y1,x2,y2,0.0,0.0,b,0,320,200,255,0]");
	if (_res) _res = MLPutSymbol( mlp, "End");
	if (_res) _res = MLFlush( mlp);
	return _res;
} /* MLInstall */


#if MLPROTOTYPES
int MLDoCallPacket( MLINK mlp)
#else
int MLDoCallPacket( mlp) MLINK mlp;
#endif
{
	return _MLDoCallPacket( mlp, _tramps, 5);
} /* MLDoCallPacket */


#if MLPROTOTYPES
static int  _definepattern( MLINK mlp, char *patt, char *args, int func_n)
#else
static int  _definepattern( mlp, patt, args, func_n)
	MLINK  mlp;
	char  *patt, *args;
	int    func_n;
#endif
{
	MLPutFunction( mlp, "DefineExternal", (long)3);
	  MLPutString( mlp, patt);
	  MLPutString( mlp, args);
	  MLPutInteger( mlp, func_n);
	return !MLError(mlp);
} /* _definepattern */


#if MLPROTOTYPES
int _MLDoCallPacket( MLINK mlp, struct func functable[], int nfuncs)
#else
int _MLDoCallPacket( mlp, functable, nfuncs)
	MLINK mlp;
	struct func functable[];
	int nfuncs;
#endif
{
	long len;
	int n, res = 0;
	struct func* funcp;

	if( ! MLGetInteger( mlp, &n) ||  n < 0 ||  n >= nfuncs) goto L0;
	funcp = &functable[n];

	if( funcp->f_nargs >= 0
	&& ( ! MLCheckFunction(mlp, "List", &len)
	     || ( !funcp->manual && (len != funcp->f_nargs))
	     || (  funcp->manual && (len <  funcp->f_nargs))
	   )
	) goto L0;

	stdlink = mlp;
	res = (*funcp->f_func)( mlp);

L0:	if( res == 0)
		res = MLClearError( mlp) && MLPutSymbol( mlp, "$Failed");
	return res && MLEndPacket( mlp) && MLNewPacket( mlp);
} /* _MLDoCallPacket */


#if MLPROTOTYPES
int MLAnswer( MLINK mlp)
#else
int MLAnswer( mlp)
	MLINK mlp;
#endif
{
	int pkt = 0;

	while( !MLDone && !MLError(mlp) && (pkt = MLNextPacket(mlp), pkt) && pkt == CALLPKT){
		MLAbort = 0;
		if( !MLDoCallPacket(mlp)) pkt = 0;
	}
	MLAbort = 0;
	return pkt;
} /* MLAnswer */



/*
	Module[ { me = $ParentLink},
		$ParentLink = contents of RESUMEPKT;
		Message[ MessageName[$ParentLink, "notfe"], me];
		me]
*/

#if MLPROTOTYPES
static int refuse_to_be_a_frontend( MLINK mlp)
#else
static int refuse_to_be_a_frontend( mlp)
	MLINK mlp;
#endif
{
	int pkt;

	MLPutFunction( mlp, "EvaluatePacket", 1);
	  MLPutFunction( mlp, "Module", 2);
	    MLPutFunction( mlp, "List", 1);
		  MLPutFunction( mlp, "Set", 2);
		    MLPutSymbol( mlp, "me");
	        MLPutSymbol( mlp, "$ParentLink");
	  MLPutFunction( mlp, "CompoundExpression", 3);
	    MLPutFunction( mlp, "Set", 2);
	      MLPutSymbol( mlp, "$ParentLink");
	      MLTransferExpression( mlp, mlp);
	    MLPutFunction( mlp, "Message", 2);
	      MLPutFunction( mlp, "MessageName", 2);
	        MLPutSymbol( mlp, "$ParentLink");
	        MLPutString( mlp, "notfe");
	      MLPutSymbol( mlp, "me");
	    MLPutSymbol( mlp, "me");
	MLEndPacket( mlp);

	while( (pkt = MLNextPacket( mlp), pkt) && pkt != SUSPENDPKT)
		MLNewPacket( mlp);
	MLNewPacket( mlp);
	return MLError( mlp) == MLEOK;
}


#if MLPROTOTYPES
int MLEvaluate( MLINK mlp, charp_ct s)
#else
int MLEvaluate( mlp, s)
	MLINK mlp;
	charp_ct s;
#endif
{
	if( MLAbort) return 0;
	return MLPutFunction( mlp, "EvaluatePacket", 1L)
		&& MLPutFunction( mlp, "ToExpression", 1L)
		&& MLPutString( mlp, s)
		&& MLEndPacket( mlp);
} /* MLEvaluate */


#if MLPROTOTYPES
int MLEvaluateString( MLINK mlp, charp_ct s)
#else
int MLEvaluateString( mlp, s)
	MLINK mlp;
	charp_ct s;
#endif
{
	int pkt;
	if( MLAbort) return 0;
	if( MLEvaluate( mlp, s)){
		while( (pkt = MLAnswer( mlp), pkt) && pkt != RETURNPKT)
			MLNewPacket( mlp);
		MLNewPacket( mlp);
	}
	return MLError( mlp) == MLEOK;
} /* MLEvaluateString */


#if MLPROTOTYPES
void MLDefaultHandler( MLINK mlp, unsigned long message, unsigned long n)
#else
void MLDefaultHandler( mlp, message, n)
	MLINK mlp;
	unsigned long message, n;
#endif
{
	switch (message){
	case MLTerminateMessage:
		MLDone = 1;
	case MLInterruptMessage:
	case MLAbortMessage:
		MLAbort = 1;
	default:
		return;
	}
}

#if MLPROTOTYPES
static int _MLMain( charpp_ct argv, charpp_ct argv_end, charp_ct commandline)
#else
static int _MLMain( argv, argv_end, commandline)
  charpp_ct argv, argv_end;
  charp_ct commandline;
#endif
{
	MLINK mlp;
	long err;

	if( !stdenv)
		stdenv = MLInitialize( (MLParametersPointer)0);
	if( stdenv == (MLEnvironment)0) goto R0;

	if( !stdhandler)
		stdhandler = MLCreateMessageHandler( stdenv, MLDefaultHandler, 0);


	mlp = commandline
		? MLOpenString( stdenv, commandline, &err)
		: MLOpenArgv( stdenv, argv, argv_end, &err);
	if( mlp == (MLINK)0){
		MLAlert( stdenv, MLErrorString( stdenv, err));
		goto R1;
	}

	if( stdyielder) MLSetYieldFunction( mlp, stdyielder);
	if( stdhandler) MLSetMessageHandler( mlp, stdhandler);

	if( MLInstall( mlp))
		while( MLAnswer( mlp) == RESUMEPKT){
			if( ! refuse_to_be_a_frontend( mlp)) break;
		}

	MLClose( mlp);
R1:	MLDeinitialize( stdenv);
	stdenv = (MLEnvironment)0;
R0:	return !MLDone;
} /* _MLMain */


int MLMainString( charp_ct commandline)
{
	return _MLMain( (charpp_ct)0, (charpp_ct)0, commandline);
}

int MLMainArgv( char** argv, char** argv_end) /* note not FAR pointers */
{   
	static char FAR * far_argv[128];
	int count = 0;
	
	while(argv < argv_end)
		far_argv[count++] = *argv++;
		 
	return _MLMain( far_argv, far_argv + count, (charp_ct)0);

}

int MLMain( int argc, charpp_ct argv)
{
 	return _MLMain( argv, argv + argc, (charp_ct)0);
}
 
