/*1:*/
#line 4 "mathpng.w"

/*39:*/
#line 694 "mathpng.w"

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "png.h"
#include "mathlink.h"

/*:39*/
#line 5 "mathpng.w"

/*11:*/
#line 181 "mathpng.w"

void ReadPNGFile(const char*fname)
{
char*gamma_str;
char file_name[256];
double screen_gamma,image_gamma;
png_uint_32 row;
png_structp png_ptr= NULL;
png_infop info_ptr= NULL;
png_uint_32 width,height;
int bit_depth,color_type,interlace_type;
png_bytep*row_pointers,trans= NULL;
int num_trans= -1;
png_color_16*trans_values= NULL;
const int ReadFile= 1;
FILE*fp;

/*38:*/
#line 675 "mathpng.w"

{
int i,j,n;

n= strlen(fname);
for(j= i= 0;i<n;i++)
if(fname[i]!='\\')
file_name[j++]= fname[i];
else if(fname[++i]=='\\')
file_name[j++]= '\\';
file_name[j++]= fname[n];file_name[j+1]= '\0';
#ifdef __WIN32__
n= strlen(file_name);
for(i= 0;i<n;i++)
if('/'==file_name[i])file_name[i]= '\\';
#endif
}


/*:38*/
#line 198 "mathpng.w"

if((fp= fopen(file_name,"rb"))==NULL)
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 200 "mathpng.w"

/*13:*/
#line 285 "mathpng.w"

png_ptr= png_create_read_struct(PNG_LIBPNG_VER_STRING,
(void*)NULL,NULL,NULL);
if(png_ptr==NULL)
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 289 "mathpng.w"


/*:13*/
#line 201 "mathpng.w"

/*15:*/
#line 304 "mathpng.w"

info_ptr= png_create_info_struct(png_ptr);
if(info_ptr==NULL)
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 307 "mathpng.w"


/*:15*/
#line 202 "mathpng.w"

/*16:*/
#line 312 "mathpng.w"

if(setjmp(png_ptr->jmpbuf))
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 314 "mathpng.w"


/*:16*/
#line 203 "mathpng.w"

/*17:*/
#line 317 "mathpng.w"

png_init_io(png_ptr,fp);


/*:17*/
#line 204 "mathpng.w"



png_read_info(png_ptr,info_ptr);

png_get_IHDR(png_ptr,info_ptr,&width,&height,&bit_depth,&color_type,
&interlace_type,NULL,NULL);
png_get_tRNS(png_ptr,info_ptr,&trans,&num_trans,&trans_values);
#ifdef NO_COLOR16

png_set_strip_16(png_ptr);
#endif


if(color_type==PNG_COLOR_TYPE_PALETTE||bit_depth<8)
png_set_expand(png_ptr);



if(png_get_valid(png_ptr,info_ptr,PNG_INFO_tRNS))
png_set_expand(png_ptr);


if((gamma_str= getenv("DISPLAY_GAMMA"))!=NULL)
screen_gamma= atof(gamma_str);

else
screen_gamma= 2.2;






if(png_get_gAMA(png_ptr,info_ptr,&image_gamma))
png_set_gamma(png_ptr,screen_gamma,image_gamma);
else
png_set_gamma(png_ptr,screen_gamma,0.45);


if(!(color_type&PNG_COLOR_MASK_ALPHA)&&num_trans<0)
png_set_filler(png_ptr,0xff,PNG_FILLER_AFTER);




png_read_update_info(png_ptr,info_ptr);

/*18:*/
#line 322 "mathpng.w"

row_pointers= calloc(height,sizeof(png_bytep));
for(row= 0;row<height;row++)
row_pointers[row]= malloc(png_get_rowbytes(png_ptr,info_ptr));

/*:18*/
#line 252 "mathpng.w"

png_read_image(png_ptr,row_pointers);
/*3:*/
#line 62 "mathpng.w"

{
int i,j;
int row_bytes;
png_bytep row;
int pixel_no;

row_bytes= png_get_rowbytes(png_ptr,info_ptr);
MLPutFunction(stdlink,"List",5);
MLPutFunction(stdlink,"List",height);
for(i= height-1;i>-1;i--){
row= row_pointers[i];
if(bit_depth<=8)
/*4:*/
#line 107 "mathpng.w"

{
MLPutFunction(stdlink,"List",row_bytes);
for(j= 0;j<row_bytes;j++)
MLPutInteger(stdlink,(int)row[j]);
}

/*:4*/
#line 75 "mathpng.w"

else{
if(!(color_type|PNG_COLOR_MASK_COLOR))
/*5:*/
#line 114 "mathpng.w"

{
pixel_no= row_bytes>>1;
MLPutFunction(stdlink,"List",pixel_no);
for(j= 0;j<row_bytes;j+= 2)
MLPutInteger(stdlink,(row[j]<<8)+row[j+1]);
}

/*:5*/
#line 78 "mathpng.w"

else
/*6:*/
#line 122 "mathpng.w"

{
pixel_no= row_bytes>>1;
MLPutFunction(stdlink,"List",pixel_no);
for(j= 0;j<row_bytes;j+= 2)
MLPutInteger(stdlink,(row[j]<<8)+row[j+1]);
}

/*:6*/
#line 80 "mathpng.w"

}
}
MLPutInteger(stdlink,width);
MLPutInteger(stdlink,height);
MLPutInteger(stdlink,(bit_depth<8?8:bit_depth));
switch(color_type){
case PNG_COLOR_TYPE_GRAY:
MLPutSymbol(stdlink,"PNGBitmap`PNGColorGray");
break;
case PNG_COLOR_TYPE_PALETTE:
MLPutSymbol(stdlink,"PNGBitmap`PNGColorPalette");
break;
case PNG_COLOR_TYPE_RGB:
MLPutSymbol(stdlink,"PNGBitmap`PNGColorRGB");
break;
case PNG_COLOR_TYPE_RGB_ALPHA:
MLPutSymbol(stdlink,"PNGBitmap`PNGColorRGBA");
break;
case PNG_COLOR_TYPE_GRAY_ALPHA:
MLPutSymbol(stdlink,"PNGBitmap`PNGColorGrayA");
break;
default:
MLPutSymbol(stdlink,"PNGBitmap`PNGColorUnkown");
}
}

/*:3*/
#line 254 "mathpng.w"


png_read_end(png_ptr,info_ptr);


png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
/*19:*/
#line 327 "mathpng.w"

if(row_pointers){
for(row= 0;row<height;row++)
if(row_pointers[row])free(row_pointers[row]);
free(row_pointers);
}

/*:19*/
#line 260 "mathpng.w"


fclose(fp);
return;
}

/*:11*/
#line 6 "mathpng.w"

/*22:*/
#line 351 "mathpng.w"

void WritePNGFile(const char*fname,
int width,int height,int bit_depth,int png_fmt,double gamma)
{
FILE*fp;
char file_name[256];

png_structp png_ptr;
png_infop info_ptr;
const int ReadFile= 0;
int row,png_color_type;
png_color_8 sig_bit;
png_bytep*row_pointers;

/*28:*/
#line 486 "mathpng.w"

/*38:*/
#line 675 "mathpng.w"

{
int i,j,n;

n= strlen(fname);
for(j= i= 0;i<n;i++)
if(fname[i]!='\\')
file_name[j++]= fname[i];
else if(fname[++i]=='\\')
file_name[j++]= '\\';
file_name[j++]= fname[n];file_name[j+1]= '\0';
#ifdef __WIN32__
n= strlen(file_name);
for(i= 0;i<n;i++)
if('/'==file_name[i])file_name[i]= '\\';
#endif
}


/*:38*/
#line 487 "mathpng.w"

fp= fopen(file_name,"wb");
if(fp==NULL){
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:28*/
#line 365 "mathpng.w"

/*14:*/
#line 297 "mathpng.w"

png_ptr= png_create_write_struct(PNG_LIBPNG_VER_STRING,
(void*)NULL,NULL,NULL);
if(png_ptr==NULL)
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 301 "mathpng.w"


/*:14*/
#line 366 "mathpng.w"

/*15:*/
#line 304 "mathpng.w"

info_ptr= png_create_info_struct(png_ptr);
if(info_ptr==NULL)
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 307 "mathpng.w"


/*:15*/
#line 367 "mathpng.w"

/*16:*/
#line 312 "mathpng.w"

if(setjmp(png_ptr->jmpbuf))
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 314 "mathpng.w"


/*:16*/
#line 368 "mathpng.w"

/*17:*/
#line 317 "mathpng.w"

png_init_io(png_ptr,fp);


/*:17*/
#line 369 "mathpng.w"

/*29:*/
#line 501 "mathpng.w"

switch(png_fmt){
case 1:png_color_type= PNG_COLOR_TYPE_GRAY;
sig_bit.gray= (unsigned char)bit_depth;
break;
case 3:png_color_type= PNG_COLOR_TYPE_RGB;
sig_bit.red= sig_bit.green= sig_bit.blue= (unsigned char)bit_depth;
break;
case 4:png_color_type= PNG_COLOR_TYPE_RGB_ALPHA;
sig_bit.red= sig_bit.green= (unsigned char)bit_depth;
sig_bit.blue= sig_bit.alpha= (unsigned char)bit_depth;
break;
default:png_color_type= PNG_COLOR_TYPE_RGB_ALPHA;
sig_bit.red= sig_bit.green= (unsigned char)bit_depth;
sig_bit.blue= sig_bit.alpha= (unsigned char)bit_depth;
break;
}
png_set_IHDR(png_ptr,info_ptr,
width,height,bit_depth,
png_color_type,
PNG_INTERLACE_NONE,
PNG_COMPRESSION_TYPE_DEFAULT,
PNG_FILTER_TYPE_BASE);
png_set_sBIT(png_ptr,info_ptr,&sig_bit);

/*:29*/
#line 370 "mathpng.w"



png_set_gAMA(png_ptr,info_ptr,gamma);

png_write_info(png_ptr,info_ptr);
/*30:*/
#line 528 "mathpng.w"


png_set_packing(png_ptr);

/*:30*/
#line 376 "mathpng.w"

/*7:*/
#line 131 "mathpng.w"

{
int i,j,k;
long row_bytes;
long rb_alloc;
png_bytep row;
long imh;
int*img_row;

rb_alloc= png_get_rowbytes(png_ptr,info_ptr);
row_pointers= calloc(height,sizeof(png_bytep));

if(!MLCheckFunction(stdlink,"List",&imh)&&imh!=height)
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 144 "mathpng.w"

for(i= height-1;i>-1;i--){
MLGetIntegerList(stdlink,&img_row,&row_bytes);
row_pointers[i]= calloc(rb_alloc,sizeof(png_byte));
row= row_pointers[i];
if(bit_depth==8){
for(j= 0;j<row_bytes;j++)
row[j]= (png_byte)img_row[j];
}
else if(bit_depth==16){
for(k= j= 0;j<row_bytes;j++){
row[k++]= (png_byte)(img_row[j]>>8);
row[k++]= (png_byte)(img_row[j]);
if(k>=rb_alloc)break;
}
}
MLDisownIntegerList(stdlink,img_row,row_bytes);
}
}

/*:7*/
#line 377 "mathpng.w"

png_write_image(png_ptr,row_pointers);
png_write_end(png_ptr,info_ptr);
/*19:*/
#line 327 "mathpng.w"

if(row_pointers){
for(row= 0;row<height;row++)
if(row_pointers[row])free(row_pointers[row]);
free(row_pointers);
}

/*:19*/
#line 380 "mathpng.w"


png_destroy_write_struct(&png_ptr,(png_infopp)NULL);

fclose(fp);
MLPutString(stdlink,file_name);
return;
}

/*:22*/
#line 7 "mathpng.w"

/*24:*/
#line 399 "mathpng.w"

void WritePNGGraphics(const char*fname,double gamma)
{
FILE*fp;
char file_name[256];
char*uni_str,*end_str;
char*sp,*pbm,*image_data;
long int j;
unsigned long i;
unsigned long len;
const int png_fmt= 3;
int width,height,bit_depth;
png_structp png_ptr;
png_infop info_ptr;
const int ReadFile= 0;
int png_color_type;
png_color_8 sig_bit;
png_bytep*row_pointers;

/*25:*/
#line 453 "mathpng.w"

MLGetString(stdlink,(const char**)&uni_str);
len= strlen(uni_str);
end_str= uni_str+len;
image_data= pbm= (char*)calloc(len,sizeof(char));
for(j= i= 0,sp= uni_str;i<len;i++){
pbm[j++]= (char)MLNextCharacter((const char**)&sp,(const char*)end_str);
if(!pbm)break;
}
MLDisownString(stdlink,uni_str);

/*:25*/
#line 418 "mathpng.w"

/*26:*/
#line 464 "mathpng.w"

{

while(*pbm!='\012')pbm++;
sscanf(++pbm,"%d %d\n",&width,&height);
while(*pbm!='\012')pbm++;
sscanf(++pbm,"%d",&bit_depth);
bit_depth= 8;
while(*pbm!='\012')pbm++;
pbm++;
}

/*:26*/
#line 419 "mathpng.w"

/*28:*/
#line 486 "mathpng.w"

/*38:*/
#line 675 "mathpng.w"

{
int i,j,n;

n= strlen(fname);
for(j= i= 0;i<n;i++)
if(fname[i]!='\\')
file_name[j++]= fname[i];
else if(fname[++i]=='\\')
file_name[j++]= '\\';
file_name[j++]= fname[n];file_name[j+1]= '\0';
#ifdef __WIN32__
n= strlen(file_name);
for(i= 0;i<n;i++)
if('/'==file_name[i])file_name[i]= '\\';
#endif
}


/*:38*/
#line 487 "mathpng.w"

fp= fopen(file_name,"wb");
if(fp==NULL){
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:28*/
#line 420 "mathpng.w"

/*14:*/
#line 297 "mathpng.w"

png_ptr= png_create_write_struct(PNG_LIBPNG_VER_STRING,
(void*)NULL,NULL,NULL);
if(png_ptr==NULL)
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 301 "mathpng.w"


/*:14*/
#line 421 "mathpng.w"

/*15:*/
#line 304 "mathpng.w"

info_ptr= png_create_info_struct(png_ptr);
if(info_ptr==NULL)
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 307 "mathpng.w"


/*:15*/
#line 422 "mathpng.w"

/*16:*/
#line 312 "mathpng.w"

if(setjmp(png_ptr->jmpbuf))
/*12:*/
#line 266 "mathpng.w"

{
if(fp)fclose(fp);
if(png_ptr){
if(ReadFile)
png_destroy_read_struct(&png_ptr,&info_ptr,(png_infopp)NULL);
else
png_destroy_write_struct(&png_ptr,(png_infopp)NULL);
}
MLPutSymbol(stdlink,"$Failed");
return;
}

/*:12*/
#line 314 "mathpng.w"


/*:16*/
#line 423 "mathpng.w"

/*17:*/
#line 317 "mathpng.w"

png_init_io(png_ptr,fp);


/*:17*/
#line 424 "mathpng.w"

/*29:*/
#line 501 "mathpng.w"

switch(png_fmt){
case 1:png_color_type= PNG_COLOR_TYPE_GRAY;
sig_bit.gray= (unsigned char)bit_depth;
break;
case 3:png_color_type= PNG_COLOR_TYPE_RGB;
sig_bit.red= sig_bit.green= sig_bit.blue= (unsigned char)bit_depth;
break;
case 4:png_color_type= PNG_COLOR_TYPE_RGB_ALPHA;
sig_bit.red= sig_bit.green= (unsigned char)bit_depth;
sig_bit.blue= sig_bit.alpha= (unsigned char)bit_depth;
break;
default:png_color_type= PNG_COLOR_TYPE_RGB_ALPHA;
sig_bit.red= sig_bit.green= (unsigned char)bit_depth;
sig_bit.blue= sig_bit.alpha= (unsigned char)bit_depth;
break;
}
png_set_IHDR(png_ptr,info_ptr,
width,height,bit_depth,
png_color_type,
PNG_INTERLACE_NONE,
PNG_COMPRESSION_TYPE_DEFAULT,
PNG_FILTER_TYPE_BASE);
png_set_sBIT(png_ptr,info_ptr,&sig_bit);

/*:29*/
#line 425 "mathpng.w"



png_set_gAMA(png_ptr,info_ptr,gamma);

png_write_info(png_ptr,info_ptr);
/*30:*/
#line 528 "mathpng.w"


png_set_packing(png_ptr);

/*:30*/
#line 431 "mathpng.w"

/*27:*/
#line 476 "mathpng.w"

{int i;

png_get_rowbytes(png_ptr,info_ptr);
row_pointers= calloc(height,sizeof(png_bytep));
for(i= 0;i<height;i++)
row_pointers[i]= (png_bytep)(pbm+3*width*i);
}

/*:27*/
#line 432 "mathpng.w"

png_write_image(png_ptr,row_pointers);
png_write_end(png_ptr,info_ptr);
free(row_pointers);

png_destroy_write_struct(&png_ptr,(png_infopp)NULL);

fclose(fp);
MLPutFunction(stdlink,"List",5);
MLPutString(stdlink,file_name);
MLPutInteger(stdlink,width);
MLPutInteger(stdlink,height);
MLPutInteger(stdlink,bit_depth);
MLPutInteger(stdlink,strlen(image_data));
free(image_data);
return;
}

/*:24*/
#line 8 "mathpng.w"

/*32:*/
#line 544 "mathpng.w"

void MakeHexString(int*row,long len)
{char*hex,one[2];
long i;

hex= calloc(2*len+1,sizeof(char));
*hex= '\0';
for(i= 0L;i<len;i++){
sprintf(one,"%02X",(unsigned char)row[i]);
strcat(hex,one);
}
MLPutString(stdlink,hex);
free(hex);
}

/*:32*/
#line 9 "mathpng.w"

/*36:*/
#line 581 "mathpng.w"

#define Image(mat,i,j) mat[i+j*xsize]
#if defined(__BORLANDC__)
#  define LONGDOUBLE long double
#  define LONGLOG    logl
#  define LONGSQRT   sqrtl
#  define TWO        (2.0L)
#  define HALF       (0.5L)
#elif defined(__SUNPRO_C)
#  define LONGDOUBLE long double
#  define LONGLOG    log
#  define LONGSQRT   sqrt
#  define TWO        (2.0L)
#  define HALF       (0.5L)

#else
#  define LONGDOUBLE double
#  define LONGLOG    log
#  define LONGSQRT   sqrt
#  define TWO        (2.0)
#  define HALF       (0.5)
#endif

void RawMandelJulia(double x1,double y1,
double x2,double y2,
double cx,double cy,
double bound,
int makeJulia,
int xsize,int ysize,
int maxiter,
int makePot)
{int*mat= NULL;
double*dmat= NULL;
LONGDOUBLE dx,dy,pot;
int i,j,iter,k;
register LONGDOUBLE ccx,ccy,xx,yy,x,y,xsq,ysq,xsave,lbound;

if(makePot)
dmat= calloc(xsize*ysize,sizeof(double));
else
mat= calloc(xsize*ysize,sizeof(int));
lbound= (bound*bound);
ccx= (LONGDOUBLE)cx;
ccy= (LONGDOUBLE)cy;
dx= ((x2-x1)/(xsize-1));
dy= ((y2-y1)/(ysize-1));
for(i= 0;i<xsize;i++){
xx= (x1+dx*(i+HALF));
if(!makeJulia)ccx= xx;
for(j= 0;j<ysize;j++){
iter= 0;
x= xx;
yy= y= (y1+dy*(j+HALF));
if(!makeJulia)ccy= yy;
xsq= x*x;
ysq= y*y;
do{
xsave= x;
x= ccx+xsq-ysq;
y= ccy+TWO*y*xsave;
xsq= x*x;
ysq= y*y;
}
while(++iter<maxiter&&(xsq+ysq)<lbound);
if(!makePot)
Image(mat,i,j)= iter;
else{
if(iter==maxiter)
pot= 0.0;
else{
pot= LONGSQRT(xsq+ysq);
for(k= iter;k>0;k--)
pot= LONGSQRT(pot);
pot= LONGLOG(pot);
}
Image(dmat,i,j)= pot;
}
}
}

MLPutFunction(stdlink,"Partition",2);
if(!makePot)
MLPutIntegerList(stdlink,mat,xsize*ysize);
else
MLPutRealList(stdlink,dmat,xsize*ysize);
MLPutInteger(stdlink,xsize);
MLEndPacket(stdlink);
if(!makePot)
free(mat);
else
free(dmat);
}

/*:36*/
#line 10 "mathpng.w"

/*2:*/
#line 14 "mathpng.w"

:Evaluate:Print["mathpng MathLink program installed. \\[Copyright] Jens-Peer Kuska 1998."]

#ifdef __WIN32__
#  if MLVERSION < 3

int PASCAL WinMain(HANDLE hinstCurrent,HANDLE hinstPrevious,
LPSTR lpszCmdLine,int nCmdShow)

{char buff[512];
char FAR*argv[32];
int argc;

if(!MLInitializeIcon(hinstCurrent,nCmdShow))return 1;
argc= MLStringToArgv(lpszCmdLine,buff,argv,32);
return MLMain(argc,argv);
}

#  else

int PASCAL WinMain(HANDLE hinstCurrent,HANDLE hinstPrevious,

LPSTR lpszCmdLine,int nCmdShow)

{

char buff[512];
char FAR*buff_start= buff;
char FAR*argv[32];
char FAR*FAR*argv_end= argv+32;

if(!MLInitializeIcon(hinstCurrent,nCmdShow))return 1;
MLScanString(argv,&argv_end,&lpszCmdLine,&buff_start);
return MLMain(argv_end-argv,argv);
}

#  endif

#else

int main(int argc,char*argv[]){

return MLMain(argc,argv);
}

#endif


/*:2*//*8:*/
#line 164 "mathpng.w"

:Begin:
:Function: ReadPNGFile 
:Pattern: PNGBitmap`RawReadPNGBitmap[pngfile_String] 
:Arguments: {pngfile}                   
:ArgumentTypes: {String}                
:ReturnType: Manual                     
:End:

/*:8*//*9:*/
#line 173 "mathpng.w"

:Evaluate:SetAttributes[PNGBitmap,HoldAll] 

/*:9*//*10:*/
#line 176 "mathpng.w"

:Evaluate: Format[PNGBitmap[data_,w_,h_,d_]]:=                           
    SequenceForm["PNGBitmap","[","<<image data>>",",",w,",",h,",",d,"]"] 


/*:10*//*20:*/
#line 336 "mathpng.w"

:Begin:
:Function: WritePNGFile                                                
:Pattern: PNGBitmap`RawWritePNGBitmap[pngfile_String,w_Integer,h_Integer, 
                       bd_Integer,cno_Integer,gamma_Real,img_]         
:Arguments: {pngfile,w,h,bd,cno,gamma,img}                             
:ArgumentTypes: {String,Integer,Integer,Integer,Integer,Real,Manual}   
:ReturnType: Manual                                                    
:End:

/*:20*//*21:*/
#line 346 "mathpng.w"

:Evaluate: PNGBitmap`RawWritePNGBitmap[pngfile_String,                     
             PNGBitmap[img_,w_Integer,h_Integer,bd_Integer]]:=   
             PNGBitmap`WritePNGBitmap[pngfile,w,h,bd,4,2.2,img]            

/*:21*//*23:*/
#line 389 "mathpng.w"

:Begin:
:Function: WritePNGGraphics                                       
:Pattern: PNGBitmap`RawWritePNGGraphics[pngfile_String,           
                                        gamma_Real,pbm_String]    
:Arguments: {pngfile,gamma,pbm}                                   
:ArgumentTypes: {String,Real,Manual}                              
:ReturnType: Manual                                               
:End:

/*:23*//*31:*/
#line 534 "mathpng.w"

:Begin:
:Function: MakeHexString                                                
:Pattern: PNGBitmap`MakeHexRow[onerow_ /; VectorQ[onerow,IntegerQ]]            
:Arguments: {onerow}                                                 
:ArgumentTypes: {IntegerList}                                        
:ReturnType: Manual                                                  
:End:

/*:31*//*34:*/
#line 563 "mathpng.w"

:Begin:
:Function: RawMandelJulia                                                      
:Pattern: PNGBitmap`RawMandelJulia[x1_Real,y1_Real,x2_Real,y2_Real,            
                                   cx_Real,cy_Real,                            
                                   b_Real,makeJulia_Integer,                   
                                   xsize_Integer,ysize_Integer,                
                                   maxit_Integer,makePot_Integer]              
:Arguments: {x1,y1,x2,y2,cx,cy,b,makeJulia,xsize,ysize,maxit,makePot}          
:ArgumentTypes: {Real,Real,Real,Real,Real,Real,Real,Integer,                   
                 Integer,Integer,Integer,Integer}                              
:ReturnType: Manual                                                            
:End:

/*:34*//*35:*/
#line 577 "mathpng.w"

:Evaluate: PNGBitmap`RawMandelJulia[x1_,y1_,x2_,y2_,b_]:=                      
             PNGBitmap`RawMandelJulia[x1,y1,x2,y2,0.0,0.0,b,0,320,200,255,0]   

/*:35*/
#line 11 "mathpng.w"


/*:1*/
